-module(semuser).
-export([run/0]).
-import(semaphore_fsm,[p/1,v/1]).

run() ->
    Mutex = semaphore_fsm:make(1),
    spawn(fun() -> loop(["Hi","Ho"], Mutex) end),
    spawn(fun() -> loop(["Chee","Tah"], Mutex) end).

loop([], _) -> 
    ok;
loop([H|T], Mutex) ->
    timer:sleep(500),
    p(Mutex),
    io:format("My string is ~p.~n", [H]),
    timer:sleep(500),
    v(Mutex),
    loop(T, Mutex).
