-module(list_stuff).
-export([append/2, reverse/1]).

reverse(Xs) ->
    reverse_a(Xs, []).

reverse_a([X|Xs], Acc) ->
    reverse_a(Xs, [X|Acc]);
reverse_a([],     Acc) ->
    Acc.

append(Xs, Ys) ->
    reverse_a(reverse(Xs),Ys).
